> For the complete documentation index, see [llms.txt](https://docs.p4.software/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.p4.software/english-1/clients-1.md).

# Clients

## GET /clients

> Returns all clients

```json
{"openapi":"3.0.1","info":{"title":"P4W Api Gateway","version":"v1"},"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"Api key taken from 'Gateway API key' setting.","name":"ApiKey","in":"header"}},"schemas":{"ClientGetList":{"type":"object","properties":{"description":{"type":"string","nullable":true},"ssccCompanyId":{"type":"string","nullable":true},"companyName":{"type":"string","nullable":true},"email":{"type":"string","nullable":true},"phone":{"type":"string","nullable":true},"contactPerson":{"type":"string","nullable":true},"taxId":{"type":"string","nullable":true},"address1":{"type":"string","nullable":true},"address2":{"type":"string","nullable":true},"city":{"type":"string","nullable":true},"stateProvince":{"type":"string","nullable":true},"zipPostalCode":{"type":"string","nullable":true},"country":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"name":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/clients":{"get":{"tags":["Clients"],"summary":"Returns all clients","parameters":[{"name":"clientName","in":"query","description":"","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ClientGetList"}}},"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ClientGetList"}}},"text/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ClientGetList"}}}}}}}}}}
```

## POST /clients

> Create new client

```json
{"openapi":"3.0.1","info":{"title":"P4W Api Gateway","version":"v1"},"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"Api key taken from 'Gateway API key' setting.","name":"ApiKey","in":"header"}},"schemas":{"ClientCreate":{"type":"object","properties":{"description":{"type":"string","nullable":true},"ssccCompanyId":{"type":"string","nullable":true},"companyName":{"type":"string","nullable":true},"email":{"type":"string","nullable":true},"phone":{"type":"string","nullable":true},"contactPerson":{"type":"string","nullable":true},"taxId":{"type":"string","nullable":true},"address1":{"type":"string","nullable":true},"address2":{"type":"string","nullable":true},"city":{"type":"string","nullable":true},"stateProvince":{"type":"string","nullable":true},"zipPostalCode":{"type":"string","nullable":true},"country":{"type":"string","nullable":true},"name":{"type":"string","description":"Unique client code/name (required, immutable after creation)","nullable":true}},"additionalProperties":false},"IdDocument":{"type":"object","properties":{"id":{"type":"string","format":"uuid"}},"additionalProperties":false}}},"paths":{"/clients":{"post":{"tags":["Clients"],"summary":"Create new client","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClientCreate"}},"text/json":{"schema":{"$ref":"#/components/schemas/ClientCreate"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/ClientCreate"}}}},"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/IdDocument"}},"application/json":{"schema":{"$ref":"#/components/schemas/IdDocument"}},"text/json":{"schema":{"$ref":"#/components/schemas/IdDocument"}}}},"406":{"description":"Not Acceptable","content":{"text/plain":{"schema":{"type":"string"}},"application/json":{"schema":{"type":"string"}},"text/json":{"schema":{"type":"string"}}}}}}}}}
```

## PUT /clients

> Update an existing client

```json
{"openapi":"3.0.1","info":{"title":"P4W Api Gateway","version":"v1"},"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"Api key taken from 'Gateway API key' setting.","name":"ApiKey","in":"header"}},"schemas":{"ClientUpdate":{"type":"object","properties":{"description":{"type":"string","nullable":true},"ssccCompanyId":{"type":"string","nullable":true},"companyName":{"type":"string","nullable":true},"email":{"type":"string","nullable":true},"phone":{"type":"string","nullable":true},"contactPerson":{"type":"string","nullable":true},"taxId":{"type":"string","nullable":true},"address1":{"type":"string","nullable":true},"address2":{"type":"string","nullable":true},"city":{"type":"string","nullable":true},"stateProvince":{"type":"string","nullable":true},"zipPostalCode":{"type":"string","nullable":true},"country":{"type":"string","nullable":true},"id":{"type":"string","description":"Client ID (required for update)","format":"uuid"}},"additionalProperties":false},"IdDocument":{"type":"object","properties":{"id":{"type":"string","format":"uuid"}},"additionalProperties":false}}},"paths":{"/clients":{"put":{"tags":["Clients"],"summary":"Update an existing client","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClientUpdate"}},"text/json":{"schema":{"$ref":"#/components/schemas/ClientUpdate"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/ClientUpdate"}}}},"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/IdDocument"}},"application/json":{"schema":{"$ref":"#/components/schemas/IdDocument"}},"text/json":{"schema":{"$ref":"#/components/schemas/IdDocument"}}}},"406":{"description":"Not Acceptable","content":{"text/plain":{"schema":{"type":"string"}},"application/json":{"schema":{"type":"string"}},"text/json":{"schema":{"type":"string"}}}}}}}}}
```
